import java.io.*;
import java.util.*;

public class AlexSolution {
	
	Scanner in;
	static PrintWriter out;
	
	void solve() {
		int nRows = in.nextInt();
		int nCols = in.nextInt();
		char[][] field = new char[nRows][];
		for (int row = 0; row < nRows; row++) {
			field[row] = in.next().toCharArray();
			asserT(field[row].length == nCols);
		}

		int total = 0;
		for (int row = 0; row + 3 <= nRows; row++) {
			for (int col = 0; col + 3 <= nCols; col++) {
				int ans = 0;
				for (int i = 0; i < 3; i++) {
					for (int j = 0; j < 3; j++) {
						if (field[row + i][col + j] == 'X') {
							ans++;
						}
					}
				}
				
				if (ans == 9) {
					total++;
				} else if (ans == 8 && field[row + 1][col + 1] == '.') {
					total++;
				}
			}
		}
		out.println(total);
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new AlexSolution().run();
	}
}