import java.io.*;
import java.util.*;

public class AlexSolution {
	
	Scanner in;
	static PrintWriter out;

	static class YMD {
		int year;
		int day;
		
		int dayOfWeek;
		
		YMD() {
			this.year = 2013;
			this.day = 1;
			this.dayOfWeek = 1;//vtorkik
		}
		
		static boolean isBissextile(int y) {
			if (y % 400 == 0) {
				return true;
			}
			return y % 4 == 0 && y % 100 != 0;
		}
		
		int getDaysInYear() {
			if (isBissextile(year)) {
				return 366;
			} else {
				return 365;
			}
		}
				
		void increase() {
			day++;
			dayOfWeek = (dayOfWeek + 1) % 7;
			if (day == getDaysInYear() + 1) {
				day = 1;
				year++;
			}
		}
		
		void decrease() {
			day--;
			dayOfWeek--;
			if (dayOfWeek == -1) {
				dayOfWeek = 6;
			}
			if (day == 0) {
				year--;
				day = getDaysInYear();
			}
		}
	}
	
	void solve() {
		int year = in.nextInt();
		YMD down = new YMD();
		while (!(down.year == year && down.day == 1)) {
			down.decrease(); // downto 1 jan
		}
		YMD up = new YMD();
		while (true) {
			// 1 jan both
			asserT(up.day == 1 && down.day == 1);
			if (up.dayOfWeek == down.dayOfWeek && YMD.isBissextile(up.year) == YMD.isBissextile(year)) {
				out.println(up.year);
				return;
			}
			int next = up.year + 1;
			while (up.year != next) {
				up.increase();
			}
		}
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new AlexSolution().run();
	}
}
