const NMAX = 1000000;

procedure printBin(x: longint);
var
  p2: longint;
begin
  p2 := 1;
  while p2 * 2 <= x do 
    p2 := p2 * 2;
  while p2 >= 1 do begin
    write(x div p2);
    x := x mod p2;
    p2 := p2 div 2;
  end;
end;

var
  a, b, p10, step, i: longint;
  digits: array[1..NMAX] of byte;
  steps: array[1..NMAX] of longint;
  c: char;

begin
  a := 0; c := '0';
  while c in ['0'..'9'] do begin
    a := a * 10 + ord(c) - ord('0');
    read(c);
  end;

  printBin(a);
  write('.');

  b := 0; p10 := 1;
  repeat
    read(c);
    if not (c in ['0'..'9']) then break;
    b := b * 10 + ord(c) - ord('0');
    p10 := p10 * 10;
  until false;
  
  for i := 1 to NMAX do steps[i] := 0;
  step := 0;
  while b > 0 do begin   
    if steps[b] > 0 then break;
    inc(step);
    steps[b] := step;
    b := b * 2;
    digits[step] := b div p10;
    b := b mod p10;
  end;

  for i := 1 to step do begin
    if b > 0 then 
      if i = steps[b] then
        write('(');
    write(digits[i]);
  end;
  if b > 0 then write(')');
  writeln;

end.