import java.io.*;
import java.util.*;

public class AlexSolutionNonPeriodic {
	
	Scanner in;
	static PrintWriter out;
	
	int[] convertChars(char[] s) {
		int[] res = new int[s.length];
		for (int i = 0; i < s.length; i++) {
			res[i] = s[i] - '0';
		}
		return res;
	}
	
	int gcd(int a, int b) {
		if (b == 0) {
			return a;
		} else {
			return gcd(b, a % b);
		}
	}
		
	void solve() {
		String s = in.next();
		int dotIdx = s.indexOf('.');
		asserT(dotIdx != -1);
		int before = Integer.parseInt(s.substring(0, dotIdx));
		int after = Integer.parseInt(s.substring(dotIdx + 1));
		
		StringBuilder sb = new StringBuilder();
		Stack<Integer> beforeBin = new Stack<Integer>();
		if (before == 0) {
			beforeBin.push(0);
		} else {
			while (before != 0) {
				beforeBin.push((before % 2));
				before /= 2;
			}
		}
		while (!beforeBin.isEmpty()) {
			sb.append((char)('0' + beforeBin.pop()));
		}
		sb.append('.');
		int len = s.length() - 1 - dotIdx;
		int den = 1;
		for (int i = 0; i < len; i++) {
			den *= 10;
		}
		int div = gcd(after, den);
		after /= div;
		den /= div;
		
		int nDigits = 0;
		while (den != 1) {
			asserT(den % 2 == 0);
			den /= 2;
			nDigits++;
		}
		
		Stack<Integer> afterBin = new Stack<Integer>();
		while (after != 0) {
			afterBin.push(after % 2);
			after /= 2;
		}
		while (afterBin.size() < nDigits) {
			afterBin.push(0);
		}
		while (!afterBin.isEmpty()) {
			sb.append((char)('0' + afterBin.pop()));
		}
		out.println(sb.toString());
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new AlexSolutionNonPeriodic().run();
	}
}