{$asmmode intel}

const 
  NMAX = 1000;
  TMAX = 12;
  SMAX = 4095;

type
  TsArray = array[0..SMAX] of longint;

var
  n, k, t: longint;
  s: TsArray;
  c1: array[0..65535] of longint;

function numOnesPrecalc(x: longint): longint;
var
  res: longint;
begin
  res := 0;
  while x > 0 do begin
    res := res + x mod 2;
    x := x div 2;
  end;
  numOnesPrecalc := res;
end;

procedure ReadData;
var
  monst, i, j, sk: longint;
begin
  for i := 0 to SMAX do s[i] := 0;
  read(n, k, t);
  for i := 1 to n do
  begin
    monst := 0;
    for j := 1 to t do
    begin
      read(sk);
      monst := monst * 2 + sk;
    end;
    s[monst] := 1;
  end;
  for i:=0 to 65535 do
    c1[i] := NumOnesPrecalc(i);
end;

function numOnes(x: longint): longint;
begin
  numOnes := c1[x and 65535] + c1[x shr 16];
  //numOnes := numOnesPrecalc(x);
end;

function min(a, b: longint): longint;
begin
  if a < b then min := a else min := b;
end;

procedure Solve;
var
  p, i, j, ans, cnt: longint;
begin
  for p := 1 to min(k, t) - 1 do 
  begin
    for i := 0 to SMAX - 1 do 
      for j := i + 1 to SMAX do
        if (s[i] > 0) and (s[j] > 0) and 
          (s[i] + s[j] <= k) and 
          ((s[i or j] = 0) or 
           (s[i] + s[j] < s[i or j])) 
        then
          s[i or j] := s[i] + s[j];
  end;

  ans := 0;
  for i := 0 to SMAX do 
    if s[i] > 0 then
    begin
      cnt := numOnes(i);
      if cnt > ans then ans := cnt;
    end;
  writeln(ans);
end;

begin
  ReadData;
  Solve;
end.
