import java.io.*;
import java.util.*;

public class AlexSolutionPeriodic {
	
	Scanner in;
	static PrintWriter out;
	
	int gcd(int a, int b) {
		if (b == 0) {
			return a;
		} else {
			return gcd(b, a % b);
		}
	}
		
	void solve() {
		String s = in.next();
		int dotIdx = s.indexOf('.');
		asserT(dotIdx != -1);
		int before = Integer.parseInt(s.substring(0, dotIdx));
		int after = Integer.parseInt(s.substring(dotIdx + 1));
		
		StringBuilder sb = new StringBuilder();
		Stack<Integer> beforeBin = new Stack<Integer>();
		if (before == 0) {
			beforeBin.push(0);
		} else {
			while (before != 0) {
				beforeBin.push((before % 2));
				before /= 2;
			}
		}
		while (!beforeBin.isEmpty()) {
			sb.append((char)('0' + beforeBin.pop()));
		}
		sb.append('.');
		int len = s.length() - 1 - dotIdx;
		int den = 1;
		for (int i = 0; i < len; i++) {
			den *= 10;
		}
		int div = gcd(after, den);
		after /= div;
		den /= div;
		
		int remainderUsedInPos[] = new int[2 * den + 1];
		int settle[] = new int[2 * den + 1];
		Arrays.fill(remainderUsedInPos, -1);
		int pos = 0;
		{
			remainderUsedInPos[after] = pos++;
			
			after *= 2;
			while (after != 0) {
				if (remainderUsedInPos[after] != -1) {
					int start = remainderUsedInPos[after];
					for (int p = 1; p < start; p++) {
						sb.append(settle[p]);
					}
					sb.append('(');
					for (int p = start; p < pos; p++) {
						sb.append(settle[p]);
					}
					sb.append(')');
					break;
				}
				remainderUsedInPos[after] = pos;
				if (after < den) {
					settle[pos] = 0;
					after *= 2;
				} else {
					settle[pos] = 1;
					after = (after % den) * 2;
				}
				
				pos++;
			}
			if (after == 0) {
				for (int p = 1; p < pos; p++) {
					sb.append(settle[p]);
				}
			}
		}
		out.println(sb.toString());
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	public void run() {
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
	
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new AlexSolutionPeriodic().run();
	}
}