const 
  NMAX = 1000;
  INF: Int64 = 1000000000000000;

type
  Block = record
    id: longint;
    count : int64;
  end;

var
  n, i, j: longint;
  k: array[1..NMAX + 1] of Block;
  m, cnt: int64;

procedure BubbleSortByCount;
var
  i, j: longint;
  t: Block;
begin
  for i := 1 to n - 1 do
    for j := n - 1 downto i do
      if k[j].count > k[j + 1].count then 
      begin
        t := k[j]; k[j] := k[j + 1]; k[j + 1] := t;
      end;
end;

procedure BubbleSortById;
var
  i, j: longint;
  t: Block;
begin
  for i := 1 to n - 1 do
    for j := n - 1 downto i do
      if k[j].id > k[j + 1].id then 
      begin
        t := k[j]; k[j] := k[j + 1]; k[j + 1] := t;
      end;
end;

begin
  read(n);
  for i := 1 to n do begin
    read(k[i].count);
    k[i].id := i;
  end;
  k[n + 1].id := n + 1;
  k[n + 1].count := INF;
  read(m);
  
  BubbleSortByCount;
  
  for i := 1 to n do 
  begin
    if (k[i + 1].count - k[i].count) * i <= m then 
    begin      
      m := m - (k[i + 1].count - k[i].count) * i;
      for j := 1 to i do
        k[j].count := k[i + 1].count;  
      if m = 0 then break;
    end
    else
    begin
      for j := 1 to i do
        k[j].count := k[j].count + m div i;
      m := m mod i;
      if m = 0 then break;
      cnt := k[1].count;
      BubbleSortById;
      j := 1;
      while m > 0 do begin
        if k[j].count = cnt then 
        begin
          inc(k[j].count);
          dec(m);
        end;
        inc(j);
      end;
      break;
    end;
  end;

  BubbleSortById;  
  for i := 1 to n do 
     write(k[i].count, ' ');
  writeln;

end.
              